from typing import Any
from typing import List
from typing import Set
from typing import Tuple

from . import *


class DepsgraphObjectInstance(bpy_struct):
    
    # Evaluated object which is being instanced by this iterator
    instance_object: Object
    
    # Denotes if the object is generated by another object
    is_instance: bool
    
    # Generated transform matrix in world space
    matrix_world: List[float]
    
    # Evaluated object the iterator points to
    object: Object
    
    # Generated coordinates in parent object space
    orco: Tuple[float, float, float]
    
    # If the object is an instance, the parent object that generated it
    parent: Object
    
    # Evaluated particle system that this object was instanced from
    particle_system: ParticleSystem
    
    # Persistent identifier for inter-frame matching of objects with motion blur
    persistent_id: Tuple[int, int, int, int, int, int, int, int]
    
    # Random id for this instance, typically for randomized shading
    random_id: int
    
    # Particles part of the object should be visible in the render
    show_particles: bool
    
    # The object geometry itself should be visible in the render
    show_self: bool
    
    # UV coordinates in parent object space
    uv: Tuple[float, float]

    @classmethod
    def bl_rna_get_subclass(cls, *args, **kwargs) -> Struct:
        ...

    @classmethod
    def bl_rna_get_subclass_py(cls, *args, **kwargs) -> Any:
        ...